## python-soxr 0.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15...3.26)

project(nanobind_example LANGUAGES CXX)

if (NOT SKBUILD)
    message(WARNING "\
    This CMake file is meant to be executed using 'scikit-build'. Running
    it directly will almost certainly not produce the desired result. If
    you are a user trying to install this package, please use the command
    below, which will install all necessary build dependencies, compile
    the package in an isolated environment, and then install it.
    =====================================================================
      $ pip install .
    =====================================================================
    If you are a software developer, and this is your own package, then
    it is usually much more efficient to install the build dependencies
    in your environment once and use the following command that avoids
    a costly creation of a new virtual environment at every compilation:
    =====================================================================
      $ pip install nanobind scikit-build-core[pyproject]
      $ pip install --no-build-isolation -ve .
    =====================================================================
    You may optionally add -Ceditable.rebuild=true to auto-rebuild when
    the package is imported. Otherwise, you need to re-run the above
    after editing C++ files.")
endif()

# Turn on to link libsoxr dynamically and not to bundle libsoxr in the wheel package
option(USE_SYSTEM_LIBSOXR "Build using system libsoxr" OFF)

find_package(Python 3.9
    REQUIRED COMPONENTS Interpreter Development.Module
    OPTIONAL_COMPONENTS Development.SABIModule)

find_package(nanobind CONFIG REQUIRED)

if (USE_SYSTEM_LIBSOXR)
    set(CSOXR_VER_C src/csoxr_version.cpp)
else ()
    # libsoxr VCS versioning
    set(CSOXR_VER_C ${CMAKE_CURRENT_SOURCE_DIR}/src/csoxr_ver_vcs.cpp)
    set(SOXR_VER_COMMAND ${CMAKE_COMMAND}
            -DVERSION_IN=src/csoxr_ver_vcs.cpp.in
            -DVERSION_C=${CSOXR_VER_C}
            -DVCS_REPO_DIR=libsoxr
            -P cmake/versioning.cmake
    )

    # run while CMake configuring (for sdist)
    execute_process(
        COMMAND ${SOXR_VER_COMMAND}
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )

    # run at every build time
    add_custom_target(soxr_version_vcs
        COMMAND ${SOXR_VER_COMMAND}
        BYPRODUCTS ${CSOXR_VER_C}
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )
endif ()

nanobind_add_module(soxr_ext STABLE_ABI NB_STATIC
    src/soxr_ext.cpp
    ${CSOXR_VER_C}
)

nanobind_add_stub(soxr_ext_stub
    MODULE soxr_ext
    OUTPUT soxr_ext.pyi
    PYTHON_PATH $<TARGET_FILE_DIR:soxr_ext>
    DEPENDS soxr_ext
)

target_link_libraries(soxr_ext PRIVATE
    soxr
)

# Install directive for scikit-build-core
install(TARGETS soxr_ext LIBRARY DESTINATION soxr)
install(FILES ${CMAKE_BINARY_DIR}/soxr_ext.pyi DESTINATION soxr)

if (NOT USE_SYSTEM_LIBSOXR)
    target_include_directories(soxr_ext PRIVATE
        src
        libsoxr/src
    )

    # Build static libsoxr
    option(BUILD_TESTS "" OFF)
    option(WITH_OPENMP "" OFF)  # OpenMP seems not working (dunno why). Disable it for portability anyway.
    option(WITH_LSR_BINDINGS "" OFF)
    option(BUILD_SHARED_LIBS "" OFF)  # make it shared someday?
    option(WITH_VR32 "" OFF)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
    set(CMAKE_INSTALL_PREFIX ../install)
    add_subdirectory(libsoxr libsoxr)

    # Copy licenses to package (scikit-build-core)
    install(FILES cmake/LICENSE-PFFFT.txt DESTINATION ${SKBUILD_METADATA_DIR}/licenses)
    install(FILES libsoxr/LICENCE DESTINATION ${SKBUILD_METADATA_DIR}/licenses RENAME LICENSE-libsoxr.txt)
endif ()

## python-soxr 0.4.0b1

=== debian/changelog ===
python-soxr (0.4.0b1-2) unstable; urgency=medium

  * Source-only upload to allow testing migration

 -- Josenilson Ferreira da Silva <nilsonfsilva@hotmail.com>  Thu, 11 Jul 2024 19:57:58 -0300

python-soxr (0.4.0b1-1) unstable; urgency=medium

  * Initial release. (Closes: #1072088)

 -- Josenilson Ferreira da Silva <nilsonfsilva@hotmail.com>  Sun, 26 May 2024 21:15:16 -0300

=== debian/control ===
Source: python-soxr
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Josenilson Ferreira da Silva <nilsonfsilva@hotmail.com>
Rules-Requires-Root: no
Build-Depends: cython3,
               debhelper-compat (= 13),
               dh-sequence-python3,
               dh-sequence-numpy3,
               libsoxr-dev,
               pybuild-plugin-pyproject,
               python3-all,
               python3-all-dev,
               python3-linkify-it <!nodoc>,
               python3-myst-parser <!nodoc>,
               python3-numpy,
               python3-pytest <!nocheck>,
               python3-setuptools,
               python3-setuptools-scm,
               python3-sphinx <!nodoc>,
               python3-sphinx-book-theme <!nodoc>,
               python3-wheel
Standards-Version: 4.7.0
Homepage: https://github.com/dofuuz/python-soxr
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-soxr
Vcs-Git: https://salsa.debian.org/python-team/packages/python-soxr.git
Testsuite: autopkgtest-pkg-pybuild

Package: python3-soxr
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Suggests: python-soxr-doc
Description: Convert one-dimensional sampling rate
 Soxr is a Python library designed to perform resampling of audio files,
 allowing you to convert between different sample rates efficiently and
 accurately. With this tool it is possible to obtain fast and very high
 quality results for any resampling ratio.
 .
 This package installs the library for Python 3.

Package: python-soxr-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
         ${python3:numpy},
         ${sphinxdoc:Depends}
Description: Convert one-dimensional sampling rate (cammon documentation)
 Soxr is a Python library designed to perform resampling of audio files,
 allowing you to convert between different sample rates efficiently and
 accurately. With this tool it is possible to obtain fast and very high
 quality results for any resampling ratio.
 .
 This is the common documentation package.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
export PYBUILD_NAME=soxr
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYBUILD_TEST_ARGS=-v
%:
	dh $@ --with sphinxdoc --buildsystem=pybuild

#override_dh_install-arch:
#	dh_numpy3 --package=python3-soxr
#	dh_install

execute_before_dh_sphinxdoc:
	http_proxy='http://127.0.0.1:9/' python3 -m sphinx  -d debian/doctrees  \
	-N -bhtml  docs/ debian/python-soxr-doc/usr/share/doc/python-soxr-doc/html

# Fix lintian  privacy-breach-generic
	find debian/python-soxr-doc/ -name '*.html' -exec sed -i 's/.*https:\/\/img\.shields\.io\/.*//g' {} \;

#Fix lintian font-in-non-font-package / package-installs-python-pycache-dir /extra-license-file
	find debian/python-soxr-doc/ -type d -name webfonts -exec rm -r {} +
	find debian/python-soxr-doc/ -type d -name __pycache__ -exec rm -r {} +
	find debian/python-soxr-doc/  -name 'LICENSE.txt' -exec rm -r {} +

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://github.com/dofuuz/python-soxr/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@

## python-soxr 0.5.0

=== debian/changelog ===
python-soxr (0.5.0-1) unstable; urgency=medium

  * New upstream version 0.5.0
  * debian/control: Added Build-Depends:
     - nanobind-dev
     - python3-importlib-metadata
     - python3-scikit-build-core
     - python3-typing-extensions
  * debian/copyright: Added new licensed file with FFTPACK
  * debian/patches: Adjusted for this new version
  * debian/rules: Updated flag hardening
  * debian/watch: Changed to only track stable versions

 -- Josenilson Ferreira da Silva <nilsonfsilva@hotmail.com>  Sun, 15 Sep 2024 23:26:50 -0300

=== debian/control ===
--- 
+++ 
@@ -4,22 +4,27 @@
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: Josenilson Ferreira da Silva <nilsonfsilva@hotmail.com>
 Rules-Requires-Root: no
-Build-Depends: cython3,
+Build-Depends: cmake,
+               cython3,
                debhelper-compat (= 13),
+               dh-sequence-numpy3,
                dh-sequence-python3,
-               dh-sequence-numpy3,
                libsoxr-dev,
+               nanobind-dev,
                pybuild-plugin-pyproject,
                python3-all,
                python3-all-dev,
+               python3-importlib-metadata <!nodoc>,
                python3-linkify-it <!nodoc>,
                python3-myst-parser <!nodoc>,
                python3-numpy,
                python3-pytest <!nocheck>,
+               python3-scikit-build-core,
                python3-setuptools,
                python3-setuptools-scm,
                python3-sphinx <!nodoc>,
                python3-sphinx-book-theme <!nodoc>,
+               python3-typing-extensions,
                python3-wheel
 Standards-Version: 4.7.0
 Homepage: https://github.com/dofuuz/python-soxr

=== debian/rules ===
--- 
+++ 
@@ -2,13 +2,13 @@
 #export DH_VERBOSE = 1
 export PYBUILD_NAME=soxr
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export CMAKE_ARGS := -DCMAKE_VERBOSE_MAKEFILE=ON
+export DEB_CXXFLAGS_MAINT_APPEND = -D_FORTIFY_SOURCE=2
 export PYBUILD_TEST_ARGS=-v
+
 %:
 	dh $@ --with sphinxdoc --buildsystem=pybuild
 
-#override_dh_install-arch:
-#	dh_numpy3 --package=python3-soxr
-#	dh_install
 
 execute_before_dh_sphinxdoc:
 	http_proxy='http://127.0.0.1:9/' python3 -m sphinx  -d debian/doctrees  \

=== debian/watch ===
version=4
opts=\
uversionmangle=s/[-._](rc|a|alpha|b|beta|c|post|pre)[0-9]*// \
https://github.com/dofuuz/python-soxr/tags .*/v?([0-9]+\.[0-9]+\.[0-9]+)@ARCHIVE_EXT@

## python-soxr 0.5.0.post1

=== CMakeLists.txt ===
--- 
+++ 
@@ -65,22 +65,35 @@
     ${CSOXR_VER_C}
 )
 
-nanobind_add_stub(soxr_ext_stub
-    MODULE soxr_ext
-    OUTPUT soxr_ext.pyi
-    PYTHON_PATH $<TARGET_FILE_DIR:soxr_ext>
-    DEPENDS soxr_ext
-)
+if (NOT CMAKE_CROSSCOMPILING)
+    # nanobind's stub generation requires importing the module, so skip it when cross-compiling
+    nanobind_add_stub(soxr_ext_stub
+        MODULE soxr_ext
+        OUTPUT soxr_ext.pyi
+        PYTHON_PATH $<TARGET_FILE_DIR:soxr_ext>
+        DEPENDS soxr_ext
+    )
 
-target_link_libraries(soxr_ext PRIVATE
-    soxr
-)
+    install(FILES ${CMAKE_BINARY_DIR}/soxr_ext.pyi DESTINATION soxr)
+endif ()
 
 # Install directive for scikit-build-core
 install(TARGETS soxr_ext LIBRARY DESTINATION soxr)
-install(FILES ${CMAKE_BINARY_DIR}/soxr_ext.pyi DESTINATION soxr)
 
-if (NOT USE_SYSTEM_LIBSOXR)
+if (USE_SYSTEM_LIBSOXR)
+    # Find system libsoxr
+    find_library(SOXR_LIBRARY NAMES soxr)
+    find_path(SOXR_INCLUDE_DIR soxr.h)
+
+    message (STATUS "Building with external libsoxr")
+    message(SOXR_LIBRARY="${SOXR_LIBRARY}")
+    message(SOXR_INCLUDE_DIR="${SOXR_INCLUDE_DIR}")
+
+    target_link_libraries(soxr_ext PRIVATE ${SOXR_LIBRARY})
+    target_include_directories(soxr_ext PRIVATE ${SOXR_INCLUDE_DIR})
+
+else ()
+    target_link_libraries(soxr_ext PRIVATE soxr)
     target_include_directories(soxr_ext PRIVATE
         src
         libsoxr/src

=== debian/changelog ===
python-soxr (0.5.0.post1-1) unstable; urgency=medium

  * Team upload.
  * d/watch: ".post" versions are real stable releases, find them as
    well.
  * New upstream version
  * d/gbp.conf: document default branch name
  * d/rules: set PYTHONPATH before building the docs.
  * Skip building the docs until https://bugs.debian.org/1085947 is
    fixed.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 17 Feb 2025 17:54:19 +0100

=== debian/control ===
--- 
+++ 
@@ -14,18 +14,19 @@
                pybuild-plugin-pyproject,
                python3-all,
                python3-all-dev,
-               python3-importlib-metadata <!nodoc>,
-               python3-linkify-it <!nodoc>,
-               python3-myst-parser <!nodoc>,
                python3-numpy,
                python3-pytest <!nocheck>,
                python3-scikit-build-core,
                python3-setuptools,
                python3-setuptools-scm,
-               python3-sphinx <!nodoc>,
-               python3-sphinx-book-theme <!nodoc>,
                python3-typing-extensions,
-               python3-wheel
+               python3-wheel,
+# Build-Depends-Indep: dh-sequence-sphinxdoc,
+#                      python3-sphinx <!nodoc>,
+#                      python3-importlib-metadata <!nodoc>,
+#                      python3-linkify-it <!nodoc>,
+#                      python3-myst-parser <!nodoc>,
+#                      python3-sphinx-book-theme <!nodoc>,
 Standards-Version: 4.7.0
 Homepage: https://github.com/dofuuz/python-soxr
 Vcs-Browser: https://salsa.debian.org/python-team/packages/python-soxr

=== debian/rules ===
--- 
+++ 
@@ -7,16 +7,14 @@
 export PYBUILD_TEST_ARGS=-v
 
 %:
-	dh $@ --with sphinxdoc --buildsystem=pybuild
-
+	dh $@ --buildsystem=pybuild
 
 execute_before_dh_sphinxdoc:
-	http_proxy='http://127.0.0.1:9/' python3 -m sphinx  -d debian/doctrees  \
-	-N -bhtml  docs/ debian/python-soxr-doc/usr/share/doc/python-soxr-doc/html
-
+	PYTHONPATH=$(shell pybuild --print build_dir -p $$(py3versions -dv) | awk -F:\   '{ print $$2}') \
+		   http_proxy='http://127.0.0.1:9/' python3 -m sphinx  -d debian/doctrees  \
+		   -N -bhtml  docs/ debian/python-soxr-doc/usr/share/doc/python-soxr-doc/html
 # Fix lintian  privacy-breach-generic
 	find debian/python-soxr-doc/ -name '*.html' -exec sed -i 's/.*https:\/\/img\.shields\.io\/.*//g' {} \;
-
 #Fix lintian font-in-non-font-package / package-installs-python-pycache-dir /extra-license-file
 	find debian/python-soxr-doc/ -type d -name webfonts -exec rm -r {} +
 	find debian/python-soxr-doc/ -type d -name __pycache__ -exec rm -r {} +

=== debian/watch ===
version=4
opts=\
uversionmangle=s/[-._](rc|a|alpha|b|beta|c|pre)[0-9]*// \
https://github.com/dofuuz/python-soxr/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
